export declare type EnvAndVarsWithName<T> = {
    vars: {
        [K in keyof T]: VarWithName;
    };
    env: object;
    self: EnvAndVarsWithName<T>;
};
export declare type Var = {
    default: string | undefined;
    description: string;
};
export declare type VarWithName = Var & {
    name: string;
};
export declare function str2bool(str: string | undefined): boolean;
export declare function get(envVar: VarWithName): string | undefined;
export declare function getOrDefault(envVar: VarWithName): string | undefined;
export declare function varsWithName<T>(obj: {
    [K in keyof T]: Var;
}): { [K in keyof T]: VarWithName; };
export declare function treatVarToPrint<T>(varr: VarWithName): string;
export declare function composeEnv<T>(deps: EnvAndVarsWithName<any>[], self: EnvAndVarsWithName<T>): {
    vars: {};
    env: {};
    self: EnvAndVarsWithName<T>;
};
export declare const logs: {
    envNotFound: (envPath: string) => string;
    envFound: (envPath: string) => string;
    envLoadingError: (envPath: string) => string;
    envRecursionStopped: (startDir: string, curDir: string, envRecursionStopPath: string) => string;
    cantNegateNonBoolean(envPropertyValue: string | boolean | number): string;
    cantReturnNonString(propertyPath: string, propertyType: string): string;
    pleaseProvideEnvPropertyPath(): string;
    seeAllEnvProperties(): string;
    propertyNotFound(propertyPath: string): string;
};
export declare function requireEnv(curDir: string): Promise<EnvAndVarsWithName<any> | undefined>;
export declare function findEnv(startDir: string, curDir: string): Promise<EnvAndVarsWithName<any>>;
export declare function parseVars<T>(vars: {
    [K in keyof T]: VarWithName;
}): Record<string, string | undefined>;
export declare function flattenObj(obj: Record<string, any>, parent?: any, res?: Record<string, any>): Record<string, any>;
//# sourceMappingURL=index.d.ts.map