"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.flattenObj = exports.parseVars = exports.findEnv = exports.requireEnv = exports.logs = exports.composeEnv = exports.treatVarToPrint = exports.varsWithName = exports.getOrDefault = exports.get = exports.str2bool = void 0;
var fs = require("fs");
var path = require("path");
function str2bool(str) {
    return str === "true";
}
exports.str2bool = str2bool;
function get(envVar) {
    return process.env[envVar.name];
}
exports.get = get;
function getOrDefault(envVar) {
    var _a;
    return (_a = get(envVar)) !== null && _a !== void 0 ? _a : envVar.default;
}
exports.getOrDefault = getOrDefault;
function varsWithName(obj) {
    __spreadArray([], __read(Object.keys(obj)), false).forEach(function (key) {
        obj[key]["name"] = key;
    });
    return obj;
}
exports.varsWithName = varsWithName;
function treatVarToPrint(varr) {
    var value = getOrDefault(varr);
    if (varr.default === undefined && value) {
        value += " <- CHANGED 👀️ ";
    }
    else if (value === undefined) {
        value = "[unset] Default value may vary ⚠️ ";
    }
    else if (value !== varr.default) {
        value += " <- CHANGED 👀️ ";
    }
    return value;
}
exports.treatVarToPrint = treatVarToPrint;
function detectConflictingProps(acc, d) {
    var accProps = new Set(Object.keys(acc));
    return Object.keys(d).filter(function (a) { return accProps.has(a); });
}
function composeEnv(deps, self) {
    var selfEnvs = __spreadArray(__spreadArray([], __read(deps.map(function (s) { return s.self; })), false), [self], false);
    return {
        vars: selfEnvs.reduce(function (acc, d) {
            var conflictingProps = detectConflictingProps(acc, d.vars);
            if (conflictingProps.length > 0) {
                console.error("[build-env] ERROR: Found conflicting vars.");
                console.error(conflictingProps);
                console.error("[build-env] Done.");
                process.exit(1);
            }
            return __assign(__assign({}, acc), d.vars);
        }, {}),
        env: selfEnvs.reduce(function (acc, d) {
            var conflictingProps = detectConflictingProps(acc, d.env);
            if (conflictingProps.length > 0) {
                console.error("[build-env] ERROR: Found conflicting root properties.");
                console.error(conflictingProps);
                console.error("[build-env] Done.");
                process.exit(1);
            }
            return __assign(__assign({}, acc), d.env);
        }, {}),
        self: self,
    };
}
exports.composeEnv = composeEnv;
var BUILD_ENV_RECURSION_STOP_FILE_NAME = ".build-env-root";
exports.logs = {
    envNotFound: function (envPath) {
        return "[build-env] env not found at '".concat(envPath, "'");
    },
    envFound: function (envPath) {
        return "[build-env] found env at '".concat(envPath, "'");
    },
    envLoadingError: function (envPath) {
        return "[build-env] error loading env at '".concat(envPath, "'");
    },
    envRecursionStopped: function (startDir, curDir, envRecursionStopPath) {
        return "[build-env] Couldn't load env from '".concat(startDir, "' to '").concat(curDir, "'. Stopped at '").concat(envRecursionStopPath, "'");
    },
    cantNegateNonBoolean: function (envPropertyValue) {
        return "[build-env] Cannot negate non-boolean value '".concat(envPropertyValue, "'");
    },
    cantReturnNonString: function (propertyPath, propertyType) {
        return "[build-env] Env property '".concat(propertyPath, "' is not of type \"string\", \"number\", or \"boolean\". Found \"").concat(propertyType, "\":");
    },
    pleaseProvideEnvPropertyPath: function () {
        return "[build-env] Please provide an env property path.";
    },
    seeAllEnvProperties: function () {
        return "[build-env] See all env properties with 'build-env --print-env'";
    },
    propertyNotFound: function (propertyPath) {
        return "[build-env] Env property '".concat(propertyPath, "' not found.");
    },
};
function requireEnv(curDir) {
    return __awaiter(this, void 0, void 0, function () {
        var envPathJS, envPathCJS, envPathJSExist, envPathCJSExist, envPath, e_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    envPathJS = path.resolve(curDir, "env", "index.js");
                    envPathCJS = path.resolve(curDir, "env", "index.cjs");
                    envPathJSExist = fs.existsSync(envPathJS);
                    envPathCJSExist = fs.existsSync(envPathCJS);
                    envPath = envPathJSExist ? envPathJS : envPathCJS;
                    if (!envPathJSExist && !envPathCJSExist) {
                        return [2, undefined];
                    }
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4, Promise.resolve().then(function () { return require(envPath); })];
                case 2: return [2, (_a.sent())];
                case 3:
                    e_1 = _a.sent();
                    console.info(exports.logs.envLoadingError(envPath));
                    throw e_1;
                case 4: return [2];
            }
        });
    });
}
exports.requireEnv = requireEnv;
function findEnv(startDir, curDir) {
    return __awaiter(this, void 0, void 0, function () {
        var env, envRecursionStopPath;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, requireEnv(curDir)];
                case 1:
                    env = _a.sent();
                    if (env) {
                        return [2, env];
                    }
                    envRecursionStopPath = path.resolve(curDir, BUILD_ENV_RECURSION_STOP_FILE_NAME);
                    if (fs.existsSync(envRecursionStopPath)) {
                        console.info(exports.logs.envRecursionStopped(startDir, curDir, envRecursionStopPath));
                        process.exit(1);
                    }
                    return [2, findEnv(startDir, path.dirname(curDir))];
            }
        });
    });
}
exports.findEnv = findEnv;
function parseVars(vars) {
    var result = {};
    for (var v in vars) {
        result[v] = treatVarToPrint(vars[v]);
    }
    return result;
}
exports.parseVars = parseVars;
function flattenObj(obj, parent, res) {
    if (parent === void 0) { parent = undefined; }
    if (res === void 0) { res = {}; }
    for (var key in obj) {
        var propName = parent ? parent + "." + key : key;
        if (typeof obj[key] == "object") {
            flattenObj(obj[key], propName, res);
        }
        else {
            res[propName] = obj[key];
        }
    }
    return res;
}
exports.flattenObj = flattenObj;
//# sourceMappingURL=index.js.map